Index: NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/tests/ICE_ADV1D/EXPREF/namelist_cfg
===================================================================
--- NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/tests/ICE_ADV1D/EXPREF/namelist_cfg	(revision 14589)
+++ NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/tests/ICE_ADV1D/EXPREF/namelist_cfg	(revision 15548)
@@ -12,7 +12,7 @@
 !!   namtsd       data: temperature & salinity                          (default: OFF)
 !!   namcrs       coarsened grid (for outputs and/or TOP)               (ln_crs =T)
-!!   namc1d       1D configuration options                              ("key_c1d")
-!!   namc1d_dyndmp 1D newtonian damping applied on currents             ("key_c1d")
-!!   namc1d_uvd   1D data (currents)                                    ("key_c1d")
+!!   namc1d       1D configuration options                              (ln_c1d =T)
+!!   namc1d_dyndmp 1D newtonian damping applied on currents             (ln_c1d =T)
+!!   namc1d_uvd   1D data (currents)                                    (ln_c1d =T)
 !!======================================================================
 !
@@ -49,4 +49,8 @@
       !                     !  (=F) user defined configuration  ==>>>  see usrdef(_...) modules
       cn_domcfg = "ICE_ADV1D_domcfg"    ! domain configuration filename
+/
+!-----------------------------------------------------------------------
+&namtile        !   parameters of the tiling
+!-----------------------------------------------------------------------
 /
 !!======================================================================
Index: NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/tests/ICE_ADV1D/EXPREF/namelist_cfg_120pts
===================================================================
--- NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/tests/ICE_ADV1D/EXPREF/namelist_cfg_120pts	(revision 14589)
+++ NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/tests/ICE_ADV1D/EXPREF/namelist_cfg_120pts	(revision 15548)
@@ -12,7 +12,7 @@
 !!   namtsd       data: temperature & salinity                          (default: OFF)
 !!   namcrs       coarsened grid (for outputs and/or TOP)               (ln_crs =T)
-!!   namc1d       1D configuration options                              ("key_c1d")
-!!   namc1d_dyndmp 1D newtonian damping applied on currents             ("key_c1d")
-!!   namc1d_uvd   1D data (currents)                                    ("key_c1d")
+!!   namc1d       1D configuration options                              (ln_c1d =T)
+!!   namc1d_dyndmp 1D newtonian damping applied on currents             (ln_c1d =T)
+!!   namc1d_uvd   1D data (currents)                                    (ln_c1d =T)
 !!======================================================================
 !
Index: NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/tests/ICE_ADV1D/EXPREF/namelist_cfg_240pts
===================================================================
--- NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/tests/ICE_ADV1D/EXPREF/namelist_cfg_240pts	(revision 14589)
+++ NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/tests/ICE_ADV1D/EXPREF/namelist_cfg_240pts	(revision 15548)
@@ -12,7 +12,7 @@
 !!   namtsd       data: temperature & salinity                          (default: OFF)
 !!   namcrs       coarsened grid (for outputs and/or TOP)               (ln_crs =T)
-!!   namc1d       1D configuration options                              ("key_c1d")
-!!   namc1d_dyndmp 1D newtonian damping applied on currents             ("key_c1d")
-!!   namc1d_uvd   1D data (currents)                                    ("key_c1d")
+!!   namc1d       1D configuration options                              (ln_c1d =T)
+!!   namc1d_dyndmp 1D newtonian damping applied on currents             (ln_c1d =T)
+!!   namc1d_uvd   1D data (currents)                                    (ln_c1d =T)
 !!======================================================================
 !
Index: NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/tests/ICE_ADV1D/EXPREF/namelist_cfg_60pts
===================================================================
--- NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/tests/ICE_ADV1D/EXPREF/namelist_cfg_60pts	(revision 14589)
+++ NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/tests/ICE_ADV1D/EXPREF/namelist_cfg_60pts	(revision 15548)
@@ -12,7 +12,7 @@
 !!   namtsd       data: temperature & salinity                          (default: OFF)
 !!   namcrs       coarsened grid (for outputs and/or TOP)               (ln_crs =T)
-!!   namc1d       1D configuration options                              ("key_c1d")
-!!   namc1d_dyndmp 1D newtonian damping applied on currents             ("key_c1d")
-!!   namc1d_uvd   1D data (currents)                                    ("key_c1d")
+!!   namc1d       1D configuration options                              (ln_c1d =T)
+!!   namc1d_dyndmp 1D newtonian damping applied on currents             (ln_c1d =T)
+!!   namc1d_uvd   1D data (currents)                                    (ln_c1d =T)
 !!======================================================================
 !