Index: /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/ICE/icerst.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/ICE/icerst.F90	(revision 15583)
+++ /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/ICE/icerst.F90	(revision 15584)
@@ -49,5 +49,5 @@
       !
       CHARACTER(len=20)   ::   clkt     ! ocean time-step define as a character
-      CHARACTER(len=50)   ::   clname   ! ice output restart file name
+      CHARACTER(len=100)  ::   clname   ! ice output restart file name
       CHARACTER(len=256)  ::   clpath   ! full path to ice output restart file 
       !!----------------------------------------------------------------------
@@ -69,4 +69,5 @@
             clname = TRIM(cexper)//"_"//TRIM(ADJUSTL(clkt))//"_"//TRIM(cn_icerst_out)
             clpath = TRIM(cn_icerst_outdir) 
+
             IF( clpath(LEN_TRIM(clpath):) /= '/' ) clpath = TRIM(clpath)//'/'
             IF(lwp) THEN
Index: /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/OCE/IOM/restart.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/OCE/IOM/restart.F90	(revision 15583)
+++ /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/OCE/IOM/restart.F90	(revision 15584)
@@ -60,5 +60,5 @@
       !!
       CHARACTER(LEN=20)   ::   clkt     ! ocean time-step deine as a character
-      CHARACTER(LEN=50)   ::   clname   ! ocean output restart file name
+      CHARACTER(LEN=100)  ::   clname   ! ocean output restart file name
       CHARACTER(lc)       ::   clpath   ! full path to ocean output restart file
       CHARACTER(LEN=52)   ::   clpname   ! ocean output restart file name including prefix for AGRIF
Index: /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/OCE/SBC/sbccpl.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/OCE/SBC/sbccpl.F90	(revision 15583)
+++ /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/OCE/SBC/sbccpl.F90	(revision 15584)
@@ -1083,5 +1083,9 @@
          ssnd(jps_dummy_t)%clname = 'S_OC_DUMMY_T'   
          ssnd(jps_dummy_t)%laction = .TRUE.
-      ENDIF
+
+         ! Send ocean surface currents even if they're not used. 
+         ssnd(jps_ocx1)%laction = .TRUE.
+         ssnd(jps_ocy1)%laction = .TRUE.
+     ENDIF
 
 
Index: /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/OCE/STO/stopar.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/OCE/STO/stopar.F90	(revision 15583)
+++ /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/OCE/STO/stopar.F90	(revision 15584)
@@ -746,5 +746,5 @@
       REAL(KIND=8)        ::   zrseed(4)           ! RNG seeds in real type (with same bits to save in restart)
       CHARACTER(LEN=20)   ::   clkt                ! ocean time-step defined as a character
-      CHARACTER(LEN=50)   ::   clname              ! restart file name
+      CHARACTER(LEN=100)  ::   clname              ! restart file name
       CHARACTER(LEN=9)    ::   clsto2d='sto2d_000' ! stochastic parameter variable name
       CHARACTER(LEN=9)    ::   clsto3d='sto3d_000' ! stochastic parameter variable name
Index: /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/OCE/TRD/trdmxl_rst.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/OCE/TRD/trdmxl_rst.F90	(revision 15583)
+++ /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/OCE/TRD/trdmxl_rst.F90	(revision 15584)
@@ -43,5 +43,5 @@
       INTEGER ::   jk                 ! loop indice
       CHARACTER(LEN=20)   ::   clkt     ! ocean time-step deine as a character
-      CHARACTER(LEN=50)   ::   clname   ! output restart file name
+      CHARACTER(LEN=100)  ::   clname   ! output restart file name
       CHARACTER(LEN=256)  ::   clpath   ! full path to restart file
       !!--------------------------------------------------------------------------------
Index: /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/TOP/PISCES/SED/sedrst.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/TOP/PISCES/SED/sedrst.F90	(revision 15583)
+++ /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/TOP/PISCES/SED/sedrst.F90	(revision 15584)
@@ -40,5 +40,5 @@
       !
       CHARACTER(LEN=20)   ::   clkt     ! ocean time-step define as a character
-      CHARACTER(LEN=50)   ::   clname   ! trc output restart file name
+      CHARACTER(LEN=100)  ::   clname   ! trc output restart file name
       CHARACTER(LEN=256)  ::   clpath   ! full path to ocean output restart file
       !!----------------------------------------------------------------------
@@ -215,5 +215,5 @@
       INTEGER  :: ji, jj, jk, jn
       REAL(wp), DIMENSION(1) ::  zinfo
-      CHARACTER(len=50) :: clname
+      CHARACTER(len=100) :: clname
       CHARACTER(len=20) :: cltra, name1 
       REAL(wp), DIMENSION(jpoce,jpksed)   :: zdta   
Index: /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/TOP/TRP/trdmxl_trc_rst.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/TOP/TRP/trdmxl_trc_rst.F90	(revision 15583)
+++ /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/TOP/TRP/trdmxl_trc_rst.F90	(revision 15584)
@@ -38,5 +38,5 @@
       !
       CHARACTER(LEN=20)   ::   clkt     ! ocean time-step deine as a character
-      CHARACTER(LEN=50)   ::   clname   ! output restart file name
+      CHARACTER(LEN=100)  ::   clname   ! output restart file name
       CHARACTER(LEN=256)  ::   clpath   ! full path to restart file
       CHARACTER (len=35) :: charout
Index: /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/TOP/trcrst.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/TOP/trcrst.F90	(revision 15583)
+++ /NEMO/branches/UKMO/NEMO_4.0.1_NGMS_couple_stage3/src/TOP/trcrst.F90	(revision 15584)
@@ -49,5 +49,5 @@
       !
       CHARACTER(LEN=20)   ::   clkt     ! ocean time-step define as a character
-      CHARACTER(LEN=50)   ::   clname   ! trc output restart file name
+      CHARACTER(LEN=100)  ::   clname   ! trc output restart file name
       CHARACTER(LEN=256)  ::   clpath   ! full path to ocean output restart file
       !!----------------------------------------------------------------------